/*********************************************************************

 Author        : ADI - Apps            www.analog.com/MicroConverter

 Date          : Sep. 2006

 File          : master1.c

 Hardware      : Applicable to ADuC703x 

 Description   : SPI master with interrupt to demonstrate with slave.c
 				or slave1.c
		
*********************************************************************/
#include<ADuC7033.h>

void My_IRQ_Function(void);				// IRQ Funtion Prototype 
void delay(int);
int i,j;

int main(void){ 
	IRQ = My_IRQ_Function;
	IRQEN = 0x01000;					// Enable SPI interrupt
	GP2DAT = 0x02000000;				// Enable P2.1 (GPIO8) as an output
										// GPIO8 is connected to a LED on eval board
	GP0CON = 0x10001111;				// configure GPIO on SPI
	SPIDIV = 0xFF;						// set SPI clock 20480000/(2x(1+SPIDIV))
	SPICON = 0x104B;					// enable SPI master in continuous transfer mode 
										// slave select will stay low during the all transmission
	i = 0;
while (1){								// infinite loop
//	j=IRQSTA;
	}
					
}


/********************************************************************/
/*                                                                  */
/*		Interrupt Service Rountine									*/
/*                                                                  */
/********************************************************************/

void My_IRQ_Function(){
	if ((IRQSTA & 0x01000) != 0) 
	{
		SPITX = i;
		i++;
		if (i>255) 
		{
			i=0;
			GP2DAT ^= 0x020000;					// Complement LED
 			delay(20000);
		};
	}
	return ;
}

 void delay (int length){
	while (length >=0)
    	length--;
}
